package be.iminds.ilabt.jfed.espec.model;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * FileSource
 */
public class GeneratedStitchingTestRSpecFileSource extends FileSource {
    @Nonnull private final List<String> ams; //urns or serverIds
    @Nullable private final List<String> resourceClasses; //must be null (=defaults) or match ams size!
    @Nonnull private final String nodeNamePrefix;
    @Nonnull private final List<String> nodeNames;

    public GeneratedStitchingTestRSpecFileSource(@Nonnull SourceType sourceType, @Nonnull String value, @Nonnull String basename,
                                                 @Nonnull List<String> ams,
                                                 @Nonnull List<String> resourceClasses,
                                                 @Nullable String nodeNamePrefix,
                                                 @Nullable List<String> nodeNames) {
       super(sourceType, value, basename);
       this.ams = Collections.unmodifiableList(new ArrayList<>(ams));
       this.resourceClasses = resourceClasses == null ?
               null :
               Collections.unmodifiableList(new ArrayList<>(resourceClasses));

       this.nodeNamePrefix = nodeNamePrefix == null ? "n" : nodeNamePrefix;
       this.nodeNames = nodeNames == null ?
               Collections.emptyList() :
               Collections.unmodifiableList(new ArrayList<>(nodeNames));
    }

    @Nonnull
    public List<String> getAms() {
        return ams;
    }

    @Nullable
    public List<String> getResourceClasses() {
        return resourceClasses;
    }

    @Nonnull
    public String getNodeNamePrefix() {
        return nodeNamePrefix;
    }

    @Nonnull
    public List<String> getNodeNames() {
        return nodeNames;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof GeneratedStitchingTestRSpecFileSource)) return false;
        if (!super.equals(o)) return false;

        GeneratedStitchingTestRSpecFileSource that = (GeneratedStitchingTestRSpecFileSource) o;

        if (!ams.equals(that.ams)) return false;
        return true;
    }

    @Override
    public int hashCode() {
        int result = super.hashCode();
        result = 31 * result + ams.hashCode();
        return result;
    }

    @Override
    public String toString() {
        return "GeneratedStitchingTestRSpecFileSource{" +
                "ams='" + ams + '\'' +
                "resourceClasses='" + resourceClasses + '\'' +
                ", type=" + type +
                ", value='" + value + '\'' +
                ", basename='" + basename + '\'' +
                '}';
    }
}
